## radiotray-lite 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
project(radiotray_lite)

include(FindPkgConfig)
include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
include(CPack)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")

check_c_compiler_flag("-std=c11" COMPILER_SUPPORTS_C11)
if(NOT COMPILER_SUPPORTS_C11)
    message(FATAL_ERROR "The compiler ${CMAKE_C_COMPILER} has no C11 support.")
endif()

check_cxx_compiler_flag("-std=c++11" COMPILER_SUPPORTS_CXX11)
if(NOT COMPILER_SUPPORTS_CXX11)
    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support.")
endif()

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "CMAKE_BUILD_TYPE is not set, set to default = RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()
message(STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE})

add_compile_options(-Wall)
add_compile_options(-Wextra)

set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -DELPP_NO_DEFAULT_LOG_FILE")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DELPP_NO_DEFAULT_LOG_FILE")

set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -s")

find_package(LibMagic REQUIRED)
if (NOT LIBMAGIC_FOUND)
    message(FATAL_ERROR "Couldn't find libmagic")
endif(NOT LIBMAGIC_FOUND)

find_package(Threads REQUIRED)
find_package(LibNotify REQUIRED)

pkg_check_modules(LIBXML2 REQUIRED libxml-2.0)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GTK3 REQUIRED gtk+-3.0)
pkg_check_modules(GTKMM REQUIRED gtkmm-3.0)
pkg_search_module(APPINDICATOR appindicator3-0.1)
if (NOT APPINDICATOR_FOUND)
    pkg_search_module(APPINDICATOR REQUIRED ayatana-appindicator3-0.1)
    if (APPINDICATOR_FOUND)
        set(AYATANA_APPINDICATOR true)
    endif()
endif()
if (NOT APPINDICATOR_FOUND)
    pkg_search_module(NCURSES      REQUIRED ncurses)
endif()

pkg_check_modules(CURL REQUIRED libcurl)

pkg_check_modules(GSTREAMER QUIET gstreamer-1.0)
if (NOT GSTREAMER_FOUND)
    pkg_check_modules(GSTREAMER REQUIRED gstreamer-0.10)
endif()

pkg_check_modules(GSTREAMERMM QUIET gstreamermm-1.0)
if (NOT GSTREAMERMM_FOUND)
    pkg_check_modules(GSTREAMERMM REQUIRED gstreamermm-0.10)
endif()

set(TARGET_VERSION_MAJOR 0)
set(TARGET_VERSION_MINOR 3)
set(TARGET_VERSION_PATCH 0)
set(APP_VERSION "${TARGET_VERSION_MAJOR}.${TARGET_VERSION_MINOR}.${TARGET_VERSION_PATCH}")

add_subdirectory(src)

install(
    DIRECTORY data/images DESTINATION share/radiotray-lite/
)
install(
    FILES data/bookmarks.xml DESTINATION share/radiotray-lite/
)

install(
    FILES data/radiotray-lite.desktop DESTINATION share/applications/
)

install(
    FILES data/images/radiotray-lite.png DESTINATION share/pixmaps/
)

if(NOT CPACK_DEBIAN_PACKAGE_ARCHITECTURE)
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64)
endif()

set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

configure_file(${PROJECT_SOURCE_DIR}/cmake/CPackConfig.cmake.in CPackConfig.cmake @ONLY)

=== src/CMakeLists.txt ===
include_directories(SYSTEM ${GLIB2_INCLUDE_DIRS})
include_directories(SYSTEM ${LIBXML2_INCLUDE_DIRS})
include_directories(SYSTEM ${APPINDICATOR_INCLUDE_DIRS})
include_directories(SYSTEM ${GTK3_INCLUDE_DIRS})
include_directories(SYSTEM ${GTKMM_INCLUDE_DIRS})
include_directories(SYSTEM ${GSTREAMER_INCLUDE_DIRS})
include_directories(SYSTEM ${GSTREAMERMM_INCLUDE_DIRS})
include_directories(SYSTEM ${CURL_INCLUDE_DIRS})
include_directories(SYSTEM ${LIBNOTIFY_INCLUDE_DIRS})
include_directories(SYSTEM ${LIBMAGIC_INCLUDE_DIRS})

include_directories(SYSTEM third_party)

add_definitions(-Wno-deprecated-declarations)

set(
    PLAYLIST_DECODERS
    m3u_playlist_decoder.cpp
    pls_playlist_decoder.cpp
    asx_playlist_decoder.cpp
    ram_playlist_decoder.cpp
    xspf_playlist_decoder.cpp
)

set(
    THIRD_PARTY
    third_party/pugixml/pugixml.cpp
)

add_executable(
    radiotray-lite
    radiotray-lite.cpp
    tray.cpp
    player.cpp
    about.cpp
    playlist.cpp
    notification.cpp
    config.cpp
    options.cpp
    event_manager.cpp
    ${PLAYLIST_DECODERS}
    ${THIRD_PARTY}
)
target_link_libraries(
    radiotray-lite
    ${LIBXML2_LIBRARIES}
    ${GSTREAMERMM_LIBRARIES}
    ${GTKMM_LIBRARIES}
    ${CURL_LIBRARIES}
    ${APPINDICATOR_LIBRARIES}
    ${LIBNOTIFY_LIBRARIES}
    ${LIBMAGIC_LIBRARIES}
)
set_target_properties(radiotray-lite PROPERTIES COMPILE_FLAGS "-std=c++11")
target_compile_definitions(radiotray-lite PRIVATE -DELPP_DISABLE_DEFAULT_CRASH_HANDLING)
target_compile_definitions(radiotray-lite PRIVATE -DINSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}")
target_compile_definitions(radiotray-lite PRIVATE -DAPP_VERSION="${APP_VERSION}")
if (AYATANA_APPINDICATOR)
        target_compile_definitions(radiotray-lite PRIVATE AYATANA_APPINDICATOR)
endif()

install(
    TARGETS radiotray-lite
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_executable(
        radiotray-lite-cli
        radiotray-lite-cli.cpp
        player.cpp
        playlist.cpp
        config.cpp
        options.cpp
        event_manager.cpp
        ${PLAYLIST_DECODERS}
        ${THIRD_PARTY}
        )
    target_link_libraries(
        radiotray-lite-cli
        ${LIBXML2_LIBRARIES}
        ${GSTREAMERMM_LIBRARIES}
        ${CURL_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
        ${LIBMAGIC_LIBRARIES}
        )
    set_target_properties(radiotray-lite-cli PROPERTIES COMPILE_FLAGS "-std=c++11")
    target_compile_definitions(radiotray-lite-cli PRIVATE -DELPP_DISABLE_DEFAULT_CRASH_HANDLING)
    target_compile_definitions(radiotray-lite-cli PRIVATE -DINSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}")
    target_compile_definitions(radiotray-lite-cli PRIVATE -DAPP_VERSION="${APP_VERSION}")

    install(
        TARGETS radiotray-lite-cli
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        )
endif()

=== debian/changelog ===
radiotray-lite (0.3.0-2) stable; urgency=medium

  * fix build error on Debian Bookworm

 -- mistificat0r <0mistificator0@gmail.com>  Sun, 27 Aug 2023 04:39:55 +0300

radiotray-lite (0.3.0-1) stable; urgency=medium

  * fix build error on Debian Bullseye
  * add contrib - debian
  * add contrib - rpm
  * updating radio stations

 -- mistificat0r <0mistificator0@gmail.com>  Fri, 02 Dec 2022 09:17:47 +0000

radiotray-lite (0.2.19-2) stable; urgency=medium

  * Release with @thekvs latest commits f1da589.

 -- mistificat0r <0mistificator0@gmail.com>  Fri, 02 Dec 2022 08:27:21 +0000

=== debian/control ===
Source: radiotray-lite
Section: sound
Priority: optional
Maintainer: mistificat0r
Build-Depends: debhelper (>= 9), cmake, libgtkmm-3.0-dev, libgstreamermm-1.0-dev, libcurl4-gnutls-dev, libnotify-dev, libappindicator3-dev | libayatana-appindicator3-dev, libxml2-dev, libgtk-3-dev, libglib2.0-dev, libmagic-dev,
 libunwind-dev,
 libjpeg-dev
Standards-Version: 3.9.8
Homepage: https://github.com/MistificaT0r/radiotray-lite

Package: radiotray-lite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gir1.2-gstreamer-1.0, gir1.2-notify-0.7, gir1.2-gtk-3.0, gir1.2-glib-2.0
Description: online radio streaming player
 radiotray-lite is a lightweight clone of the original Radio Tray 
 online radio streaming player rewritten in C++.
 .
 Key features:
 .
 - Runs on a Linux system tray.
 - Has minimum interface possible.
 - Plays most media formats (it uses gstreamer).
 - Supports PLS, M3U, ASX, RAM, XSPF playlists.
